MODULE Moire2;

IMPORT AESApplications,AESWindows,AESGraphics,AESEvents,AESForms;
IMPORT GEMVDIbase,VDIControls;
FROM mMoire IMPORT DoMoire,Fill;
FROM SYSTEM IMPORT ADR;

CONST Melde="[0][      Moire-Muster | | 1986 Christian Sprenger | ][ O.K. ]";
TYPE BufferType = ARRAY[0..9] OF INTEGER;

VAR handle,w1,w2,w3,w4,i : INTEGER;
    wx,wy,wb,wh,WiNr,el  : INTEGER;
    ix,iy,ib,ih,ApId     : INTEGER;
    In                   : GEMVDIbase.VDIWorkInType;
    Out                  : GEMVDIbase.VDIWorkOutType;
    Buff                 : BufferType;
    done                 : BOOLEAN;
    str                  : ARRAY[0..79] OF CHAR;
    rec,r                : GEMVDIbase.PxyArrayType;
    col                  : INTEGER;

(*------------------------------------------------------------------------*)

PROCEDURE DrawAndClip(WiNr,x,y,b,h : INTEGER;
                          VAR clip : GEMVDIbase.PxyArrayType);
CONST T = "Moire";
VAR r     : GEMVDIbase.PxyArrayType;
    Title : ARRAY[0..9] OF CHAR;
BEGIN
   AESGraphics.GrafGrowBox(0,0,0,0,x,y,b,h);     (* wachsen *)
   AESWindows.WindowOpen(WiNr,x,y,b,h);          (* zeichnen *)
   AESWindows.WindowGet(WiNr,4,clip[0],clip[1],clip[2],clip[3]);
   Title := T;                                   (* Name setzen *)
   AESWindows.WindowSet(WiNr,2,INTEGER(ADR(Title) DIV 10000H),
                               INTEGER(ADR(Title) MOD 10000H),0,0);
   DEC(clip[2]); DEC(clip[3]);
   r[0] := clip[0]; r[2] := clip[2] + clip[0];   (* Eckpunkte *)
   r[1] := clip[1]; r[3] := clip[3] + clip[1];
   VDIControls.SetClipping(handle,1,r);          (* Ausgabefenster *)
END DrawAndClip;

(*------------------------------------------------------------------------*)

PROCEDURE SetColor(rec : GEMVDIbase.PxyArrayType;
                  Buff : BufferType;
                handle : INTEGER;
               VAR col : INTEGER);
BEGIN
   IF Buff[4]=6 THEN col := 0;
                ELSE col := 1;
   END; (* IF *)
   DoMoire(rec,handle,col);
END SetColor;

(*------------------------------------------------------------------------*)

PROCEDURE FullClip(handle : INTEGER;
                 WiNr,col : INTEGER);
VAR mem     : GEMVDIbase.PxyArrayType;
    x,y,b,h : INTEGER;
BEGIN
   mem[0] := 0; mem[1] := 0; mem[2] := 639; mem[3] := 399;
   VDIControls.SetClipping(handle,1,mem); (* ganzer Bildschirm *)
   AESWindows.WindowGet(WiNr,5,x,y,b,h); (* Auengre *)
   AESWindows.WindowClose(WiNr); (* Fenster weg *)
   ClearScreen;
   DoMoire(mem,handle,col);
   ClearScreen;
   DrawAndClip(WiNr,x,y,b,h,mem); (* zeichnen & clippen *)
END FullClip;

(*------------------------------------------------------------------------*)

PROCEDURE Size(WiNr : INTEGER;
               Buff : BufferType;
            VAR rec : GEMVDIbase.PxyArrayType);
BEGIN
   AESWindows.WindowClose(WiNr); (* Fenster weg *)
   VDIControls.SetClipping(handle,0,rec); (* clipping off *)
   ClearScreen;                  (* sauber *)
   DrawAndClip(WiNr,Buff[4],Buff[5],Buff[6],Buff[7],rec);
END Size;

(*------------------------------------------------------------------------*)

PROCEDURE ClearScreen;
VAR r : GEMVDIbase.PxyArrayType;
BEGIN
   r[0]:=0; r[1]:=0; r[2]:=639; r[3]:=399;
   Fill(handle,r,1); (* schwarz *)
END ClearScreen;

(*------------------------------------------------------------------------*)

BEGIN
   ApId := AESApplications.ApplInitialise();
   handle := AESGraphics.GrafHandle(i,i,i,i);
   FOR i:=0 TO 9 DO  In[i] := 1; END; (* FOR *)
   In[10] := 2;
   VDIControls.OpenVirtualWorkstation(In,handle,Out);
   ClearScreen;
   str := Melde;
   i := AESForms.FormAlert(0,str);
   el := 1+2+4+8+32+512+1024;
    (* name + close + full + move + size + left + right *)
   WiNr := AESWindows.WindowCreate(el,0,19,640,380);    (* setzen *)
   DrawAndClip(WiNr,150,100,350,250,rec);
   AESGraphics.GrafMouse(0,NIL);                        (* Pfeil *)  
   done := FALSE;
   REPEAT
      AESEvents.EventMessage(ADR(Buff));                (* message *)
      CASE Buff[0] OF                                   (* message type *)
        22 :  done := TRUE;                          |  (* Aus-Knopf *)
        23 :  FullClip(handle,WiNr,col);             |  (* Full-Knopf *)
        24 :  SetColor(rec,Buff,handle,col);         |  (* Arrowed *)
        27 :  Size(WiNr,Buff,rec);                   |  (* Size-Knopf *)
        28 :  Size(WiNr,Buff,rec);                   |  (* Move *)
      ELSE
      END; (* CASE *)
   UNTIL done;
   AESWindows.WindowClose(WiNr);                        (* close *)
   AESWindows.WindowDelete(WiNr);
   VDIControls.CloseVirtualWorkstation(handle);
   AESApplications.ApplExit;
END Moire2.
